'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactUikitBase = require('react-uikit-base');

var _reactUikitBase2 = _interopRequireDefault(_reactUikitBase);

var _ufunc = require('ufunc');

var _ufunc2 = _interopRequireDefault(_ufunc);

var _reactUikitBadge = require('react-uikit-badge');

var _reactUikitBadge2 = _interopRequireDefault(_reactUikitBadge);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ListItem = (function (_React$Component) {
  _inherits(ListItem, _React$Component);

  function ListItem() {
    _classCallCheck(this, ListItem);

    return _possibleConstructorReturn(this, Object.getPrototypeOf(ListItem).apply(this, arguments));
  }

  _createClass(ListItem, [{
    key: 'getItemDetails',
    value: function getItemDetails(index) {
      var idx = undefined;

      if (index.charAt && index.charAt(0) === '.') {
        idx = index.match(/\$(.+)$/)[1];
      } else {
        idx = index;
      }

      return {
        component: this,
        element: _reactUikitBase2.default.helpers.getElement(this.props.kitid),
        index: idx,
        kitid: this.props.kitid
      };
    }
  }, {
    key: 'handleClick',
    value: function handleClick(e, index) {
      e.preventDefault();
      e.stopPropagation();

      if (this.props.onClick) {
        this.props.onClick(Object.assign({ item: this.getItemDetails(index) }, e));
      }
    }
  }, {
    key: 'handleSelect',
    value: function handleSelect(e, index) {
      e.preventDefault();
      e.stopPropagation();

      this.props.onSelect(Object.assign({ item: this.getItemDetails(index) }, e));
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var props = this.props;

      // CSS classes
      var cssClassNames = _reactUikitBase2.default.helpers.cleanClasses([props.active ? 'uk-active' : null, props.classes, props.className]);

      // Elements
      var badge = _ufunc2.default.maybeIf(_react2.default.createElement(_reactUikitBadge2.default, {
        kitid: 'badge-' + props.kitid,
        floats: 'right',
        body: props.badge ? props.badge.body : null,
        context: props.badge ? props.badge.context : null,
        notification: props.badge ? props.badge.notification : null
      }))(props.badge);

      var selectable = function selectable(index) {
        return _ufunc2.default.maybeIf(_react2.default.createElement('input', {
          type: 'checkbox',
          className: 'close',
          checked: props.checked,
          'data-kitid': 'input-' + props.kitid,
          onSelect: function onSelect(e, index) {
            return _this2.handleSelect(e, index);
          }
        }))(props.selectable);
      };

      var attr = _extends({}, props, _reactUikitBase2.default.events(props), {
        'data-kitid': props.kitid,
        className: cssClassNames,
        onClick: function onClick(e, index) {
          return _this2.handleClick(e, index);
        }
      });

      var link = _react2.default.createElement(
        'li',
        _extends({}, attr, {
          className: cssClassNames }),
        _react2.default.createElement(
          'a',
          { style: { display: 'block' },
            href: props.href,
            className: props.active ? 'uk-active' : null
          },
          selectable(),
          ' ',
          props.body,
          ' ',
          badge
        )
      );

      var text = _react2.default.createElement(
        'li',
        attr,
        props.selectable,
        ' ',
        props.body,
        ' ',
        props.children
      );

      // Return Component
      var component = _ufunc2.default.either(link, text);
      return component(props.href);
    }
  }]);

  return ListItem;
})(_react2.default.Component);

;

ListItem.propTypes = {
  active: _react2.default.PropTypes.bool,
  badge: _react2.default.PropTypes.object,
  body: _react2.default.PropTypes.string,
  children: _react2.default.PropTypes.any,
  className: _react2.default.PropTypes.string,
  classes: _react2.default.PropTypes.array,
  description: _react2.default.PropTypes.string,
  href: _react2.default.PropTypes.string,
  kitid: _react2.default.PropTypes.string,
  onClick: _react2.default.PropTypes.func,
  onSelect: _react2.default.PropTypes.func,
  selectable: _react2.default.PropTypes.bool
};

exports.default = _reactUikitBase2.default.base(ListItem);